import sys

if len(sys.argv)<2:
  print "infile not specified! ex: python reduce.py my_equations.txt"
  exit

infile = sys.argv[1]


prefix = ""
if len(sys.argv)>2 and sys.argv[2] == 'c++':
  prefix = "double "

# Read in the equation file
k = open(infile, "r")
lines = k.read()
k.close()

lines = lines.replace('\r','\n')
lines = lines.replace("^","**")

print "Generating reduction code from "+infile
if '/' in lines:
  print "Warning: Division not supported yet."

# Splits the equations into seperate lines
eqs = [line for line in lines.split('\n') if len(line.strip())]

# Get all symbols that are used in the equation
delims = '=+-*()^;\n'
symbols = lines
for d in delims:
  symbols = symbols.replace(d," ")
  
symbols = [thing for thing in set(symbols.split(' ')) if len(thing) and not thing.isdigit()]

# Prints the import code, defines symbols, and the equations
code = ""
code += "from PrettyCode import make_efficient_code\n"
code += "from sympy import *\n"
code += ", ".join(symbols) + " = symbols('"+ " ".join(symbols) + "')\n" 
code += lines.replace("^","**")

# Prints the line that says to reduce the code and print the output.
vars_ = " ".join((eq.split("=")[0].strip(" ") for eq in eqs))
vars_comma = ", ".join(vars_.split(" ")) 
vars_comma_quotes = "'" + "', '".join(vars_.split(" ")) + "'"
code += "\n[out, code] = make_efficient_code(["+vars_comma+"],["+vars_comma_quotes+"])\n"
code += "print out\n"
code += "code = code.replace('**','^')\n"
code += "k = open('reduced_"+infile+"', 'w')\n"
code += "lines = k.write(code)\n"
code += "k.close()\n"

k = open("simplify_me.py", "w")
lines = k.write(code);
k.close()

print "Reducing data from "+infile

import os
os.system("python simplify_me.py")
print "Saved result in reduced_"+infile
